

<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>posydon.binary_evol.singlestar &mdash; posydon 0+untagged.3754.gf69f455.dirty documentation</title>
  

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />

  
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/doctools.js"></script>
        <script src="../../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> posydon
          

          
          </a>

          
            
            
              <div class="version">
                0+untagged.3754.gf69f455.dirty
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../install/index.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/inifile.html">Configuration files for POSYDON</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/dynamic/dynamic.html">Run a Dynamic MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/fixed/fixed.html">Run a Fixed MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/PSyGrid.html">The PSyGrid Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/plot2D/plot2D.html">Showcase of 2D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/plot1D/plot1D.html">Showcase of 1D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../SingleStar/SingleStar.html">The Single Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../BinaryStar/BinaryStar.html">The Binary Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../visualization/VH_diagram.html">Van den Heuvel diagrams</a></li>
</ul>

            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">posydon</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
        
          <li><a href="../../index.html">Module code</a> &raquo;</li>
        
      <li>posydon.binary_evol.singlestar</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for posydon.binary_evol.singlestar</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;The star object describe the star current and past state.</span>

<span class="sd">The star object contains the current and past states of the star. Only parameters in</span>
<span class="sd">the STARPROPERTIES list are stored in the history. The current parameter value of the</span>
<span class="sd">star object is accessed as, e.g. `star.mass` while his past history with</span>
<span class="sd">`star.mass_history`.</span>

<span class="sd">&quot;&quot;&quot;</span>

<span class="n">__author__</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;Tassos Fragos &lt;Anastasios.Fragkos@unige.ch&gt;&#39;</span><span class="p">,</span>
              <span class="s1">&#39;Jeff Andrews &lt;jeffrey.andrews@northwestern.edu&gt;&#39;</span><span class="p">,</span>
              <span class="s1">&#39;Nam Tran &lt;tranhn03@gmail.com&gt;&#39;</span><span class="p">,</span>
              <span class="s1">&#39;Simone Bavera &lt;Simone.Bavera@unige.ch&gt;&#39;</span><span class="p">,</span>
              <span class="s1">&#39;Emmanouil Zapartas &lt;Emmanouil.Zapartas@unige.ch&gt;&#39;</span><span class="p">,</span>
              <span class="s1">&#39;Konstantinos Kovlakas &lt;kkovlakas@physics.uoc.gr&gt;&#39;</span>
              <span class="p">]</span>

<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">from</span> <span class="nn">posydon.utils.common_functions</span> <span class="kn">import</span> <span class="n">check_state_of_star</span>


<span class="n">STARPROPERTIES</span> <span class="o">=</span> <span class="p">[</span>
    <span class="s1">&#39;state&#39;</span><span class="p">,</span>  <span class="c1"># the evolutionary state of the star. Options can be found in function &quot;check_state_of_star&quot; in posydon/utils/common_functions.py</span>
    <span class="s1">&#39;metallicity&#39;</span><span class="p">,</span> <span class="c1"># Initial(?) mass fraction of metal. Constant throughout the evolution</span>
    <span class="s1">&#39;mass&#39;</span><span class="p">,</span>  <span class="c1"># mass in solar units</span>
    <span class="s1">&#39;log_R&#39;</span><span class="p">,</span> <span class="c1"># log10  of radius in solar units</span>
    <span class="s1">&#39;log_L&#39;</span><span class="p">,</span> <span class="c1"># log10 luminosity in solar units</span>
    <span class="s1">&#39;lg_mdot&#39;</span><span class="p">,</span> <span class="c1"># the  mass change of the star star due to both winds and RLO. Coming from binary history, log of abs in Msun/year.</span>
    <span class="s1">&#39;lg_system_mdot&#39;</span><span class="p">,</span> <span class="c1"># log10 of abs of mass lost from the system from around star due to inneficient mass transfer in Msun/year</span>
    <span class="s1">&#39;lg_wind_mdot&#39;</span><span class="p">,</span> <span class="c1">#  log10 of the abs of only the wind mass loss of the star. It should be coming from “lg_wind_mdot_1/2&quot; from MESA binary_history, in Msun/year.</span>
    <span class="s1">&#39;he_core_mass&#39;</span><span class="p">,</span> <span class="c1"># in solar units</span>
    <span class="s1">&#39;he_core_radius&#39;</span><span class="p">,</span> <span class="c1"># in solar units</span>
    <span class="s1">&#39;c_core_mass&#39;</span><span class="p">,</span> <span class="c1"># in solar units # TODO: These will become obsolete, replaced by co_core_*</span>
    <span class="s1">&#39;c_core_radius&#39;</span><span class="p">,</span> <span class="c1"># in solar units # TODO: These will become obsolete, replaced by co_core_*</span>
    <span class="s1">&#39;o_core_mass&#39;</span><span class="p">,</span> <span class="c1"># in solar units # TODO: These will become obsolete, replaced by co_core_*</span>
    <span class="s1">&#39;o_core_radius&#39;</span><span class="p">,</span> <span class="c1"># in solar units # TODO: These will become obsolete, replaced by co_core_*</span>
    <span class="s1">&#39;co_core_mass&#39;</span><span class="p">,</span> <span class="c1"># in solar units</span>
    <span class="s1">&#39;co_core_radius&#39;</span><span class="p">,</span><span class="c1"># in solar units</span>
    <span class="s1">&#39;center_h1&#39;</span><span class="p">,</span> <span class="c1"># mass fraction at the cetral point</span>
    <span class="s1">&#39;center_he4&#39;</span><span class="p">,</span> <span class="c1"># mass fraction at the cetral point</span>
    <span class="s1">&#39;center_c12&#39;</span><span class="p">,</span> <span class="c1"># mass fraction at the cetral point</span>
    <span class="s1">&#39;center_n14&#39;</span><span class="p">,</span> <span class="c1"># mass fraction at the cetral point</span>
    <span class="s1">&#39;center_o16&#39;</span><span class="p">,</span> <span class="c1"># mass fraction at the cetral point</span>
    <span class="s1">&#39;surface_h1&#39;</span><span class="p">,</span> <span class="c1"># mass fraction at the surface</span>
    <span class="s1">&#39;surface_he4&#39;</span><span class="p">,</span> <span class="c1"># mass fraction at the surface</span>
    <span class="s1">&#39;surface_c12&#39;</span><span class="p">,</span> <span class="c1"># mass fraction at the surface</span>
    <span class="s1">&#39;surface_n14&#39;</span><span class="p">,</span> <span class="c1"># mass fraction at the surface</span>
    <span class="s1">&#39;surface_o16&#39;</span><span class="p">,</span> <span class="c1"># mass fraction at the surface</span>
    <span class="s1">&#39;log_LH&#39;</span><span class="p">,</span> <span class="c1"># energy production from H burning, in solar units</span>
    <span class="s1">&#39;log_LHe&#39;</span><span class="p">,</span> <span class="c1"># energy production from He burning,  in solar units</span>
    <span class="s1">&#39;log_LZ&#39;</span><span class="p">,</span> <span class="c1"># energy production from all non-H and non-He burning,  in solar units</span>
    <span class="s1">&#39;log_Lnuc&#39;</span><span class="p">,</span> <span class="c1"># total energy production from nuclear burning,  in solar units</span>
    <span class="s1">&#39;c12_c12&#39;</span><span class="p">,</span> <span class="c1">#  energy production from Carbon burning through c12-c12 nuclear reaction, in solar units</span>
    <span class="s1">&#39;center_gamma&#39;</span><span class="p">,</span>
    <span class="s1">&#39;avg_c_in_c_core&#39;</span><span class="p">,</span> <span class="c1"># average carbon mass fraction at the carbon core of the star.</span>
    <span class="s1">&#39;surf_avg_omega&#39;</span><span class="p">,</span> <span class="c1"># surface average rotational angular velocity of the star, in rad/sec</span>
    <span class="s1">&#39;surf_avg_omega_div_omega_crit&#39;</span><span class="p">,</span> <span class="c1"># ratio of surf_avg_omega to the surface critical rotation limit (taking into account centrifugal force and radiation pressure (through Eddington limit)).</span>
    <span class="s1">&#39;total_moment_of_inertia&#39;</span><span class="p">,</span> <span class="c1"># the total moment of inertia of the star, in grams*cm^2 (cgs)</span>
    <span class="s1">&#39;log_total_angular_momentum&#39;</span><span class="p">,</span><span class="c1"># log10 of total angular momentum, in grams*cm^2/s (cgs)</span>
    <span class="s1">&#39;spin&#39;</span><span class="p">,</span> <span class="c1"># the dimesionless spin of the star, if it is a compact object, which is equal to c*J/(GM^2), with c : speed of light in vacuum;  G : the gravitationl constant ; J, M : the stellar total angular momentum and mass, respectively.</span>
    <span class="s1">&#39;conv_env_top_mass&#39;</span><span class="p">,</span>
    <span class="s1">&#39;conv_env_bot_mass&#39;</span><span class="p">,</span>
    <span class="s1">&#39;conv_env_top_radius&#39;</span><span class="p">,</span>
    <span class="s1">&#39;conv_env_bot_radius&#39;</span><span class="p">,</span>
    <span class="s1">&#39;conv_env_turnover_time_g&#39;</span><span class="p">,</span>
    <span class="s1">&#39;conv_env_turnover_time_l_b&#39;</span><span class="p">,</span>
    <span class="s1">&#39;conv_env_turnover_time_l_t&#39;</span><span class="p">,</span>
    <span class="s1">&#39;envelope_binding_energy&#39;</span><span class="p">,</span>
    <span class="s1">&#39;mass_conv_reg_fortides&#39;</span><span class="p">,</span>
    <span class="s1">&#39;thickness_conv_reg_fortides&#39;</span><span class="p">,</span>
    <span class="s1">&#39;radius_conv_reg_fortides&#39;</span><span class="p">,</span>
    <span class="s1">&#39;lambda_CE_1cent&#39;</span><span class="p">,</span>
    <span class="s1">&#39;lambda_CE_10cent&#39;</span><span class="p">,</span>
    <span class="s1">&#39;lambda_CE_30cent&#39;</span><span class="p">,</span>
    <span class="s1">&#39;lambda_CE_pure_He_star_10cent&#39;</span><span class="p">,</span>
    <span class="s1">&#39;profile&#39;</span> <span class="c1"># the profile of the star, including extended information of its internal structure, for a specific timestep, usually for the end of the previous step including MESA psygrid.</span>
<span class="p">]</span>

<span class="c1"># attributes read from single-star grid runs</span>
<span class="n">STAR_ATTRIBUTES_FROM_STAR_HISTORY_SINGLE</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s1">&#39;state&#39;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>                      <span class="c1"># to be computed after loading</span>
    <span class="s1">&#39;metallicity&#39;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>                <span class="c1"># from initial values</span>
    <span class="s1">&#39;mass&#39;</span><span class="p">:</span> <span class="s2">&quot;star_mass&quot;</span><span class="p">,</span>
    <span class="s1">&#39;spin&#39;</span><span class="p">:</span> <span class="s1">&#39;spin_parameter&#39;</span><span class="p">,</span>
    <span class="s1">&#39;profile&#39;</span><span class="p">:</span> <span class="kc">None</span>
<span class="p">}</span>


<div class="viewcode-block" id="SingleStar"><a class="viewcode-back" href="../../../api/posydon.binary_evol.singlestar.html#posydon.binary_evol.singlestar.SingleStar">[docs]</a><span class="k">class</span> <span class="nc">SingleStar</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;A class containing a star.&quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Constructor of SingleStar class.</span>

<span class="sd">        Arguments</span>
<span class="sd">        ---------</span>
<span class="sd">        **kwargs : dict</span>
<span class="sd">          List of initialization parameters for a star.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># Set the initial star properties</span>
        <span class="k">for</span> <span class="n">item</span> <span class="ow">in</span> <span class="n">STARPROPERTIES</span><span class="p">:</span>
            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">item</span><span class="p">,</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="n">item</span><span class="p">,</span> <span class="kc">None</span><span class="p">))</span>
            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">item</span> <span class="o">+</span> <span class="s1">&#39;_history&#39;</span><span class="p">,</span> <span class="p">[</span><span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">item</span><span class="p">)])</span>
        <span class="k">for</span> <span class="n">item</span><span class="p">,</span> <span class="n">val</span> <span class="ow">in</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">item</span><span class="p">,</span> <span class="n">val</span><span class="p">)</span>

        <span class="c1"># store extra values in the star object without a history</span>

        <span class="c1"># these quantities are updated in step_SN.py</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;natal_kick_array&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">natal_kick_array</span> <span class="o">=</span> <span class="p">[</span><span class="kc">None</span><span class="p">]</span> <span class="o">*</span> <span class="mi">4</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;spin_orbit_tilt&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">spin_orbit_tilt</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;spin_vector&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">spin_vector</span> <span class="o">=</span> <span class="p">[</span><span class="kc">None</span><span class="p">]</span> <span class="o">*</span> <span class="mi">3</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;f_fb&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">f_fb</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;SN_type&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">SN_type</span> <span class="o">=</span> <span class="kc">None</span>

        <span class="c1"># these quantities are updated in mesa_step.py</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;avg_c_in_c_core_at_He_depletion&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">avg_c_in_c_core_at_He_depletion</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;co_core_mass_at_He_depletion&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">co_core_mass_at_He_depletion</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;m_env_CE_1cent&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">m_env_CE_1cent</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;m_env_CE_10cent&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">m_env_CE_10cent</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;m_env_CE_30cent&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">m_env_CE_30cent</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;m_env_CE_pure_He_star_10cent&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">m_env_CE_pure_He_star_10cent</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;r_env_CE_1cent&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">r_env_CE_1cent</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;r_env_CE_10cent&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">r_env_CE_10cent</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;r_env_CE_30cent&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">r_env_CE_30cent</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;r_env_CE_pure_He_star_10cent&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">r_env_CE_pure_He_star_10cent</span> <span class="o">=</span> <span class="kc">None</span>

        <span class="c1"># these quanties are updated in cosmic_bse.py</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;kstar_preCE&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">kstar_preCE</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;kstar_postCE&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">kstar_postCE</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;mass_preSMT&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">mass_preSMT</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;mass_postSMT&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">mass_postSMT</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;spin_postSMT&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">spin_postSMT</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;spin_postCE&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">spin_postCE</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;disk_mass_accreted&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">spin_postCE</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;disk_mass_radiated&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">spin_postCE</span> <span class="o">=</span> <span class="kc">None</span>

<div class="viewcode-block" id="SingleStar.append_state"><a class="viewcode-back" href="../../../api/posydon.binary_evol.singlestar.html#posydon.binary_evol.singlestar.SingleStar.append_state">[docs]</a>    <span class="k">def</span> <span class="nf">append_state</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Append the new version of the star to the end of the star state.&quot;&quot;&quot;</span>
        <span class="k">for</span> <span class="n">item</span> <span class="ow">in</span> <span class="n">STARPROPERTIES</span><span class="p">:</span>
            <span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">item</span> <span class="o">+</span> <span class="s1">&#39;_history&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">item</span><span class="p">))</span></div>

<div class="viewcode-block" id="SingleStar.restore"><a class="viewcode-back" href="../../../api/posydon.binary_evol.singlestar.html#posydon.binary_evol.singlestar.SingleStar.restore">[docs]</a>    <span class="k">def</span> <span class="nf">restore</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">i</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Restore the object to the i-th state.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        i : int</span>
<span class="sd">            Index of the star object history to reset the star to. By default i == 0,</span>
<span class="sd">            meaning that the star will be restored to its initial state.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># Move current star properties to the ith step, using its history</span>
        <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">STARPROPERTIES</span><span class="p">:</span>
            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">p</span><span class="p">,</span> <span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;</span><span class="si">{}</span><span class="s1">_history&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">p</span><span class="p">))[</span><span class="n">i</span><span class="p">])</span>

        <span class="c1"># Remove the obsolete history data</span>
        <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">STARPROPERTIES</span><span class="p">:</span>
            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">p</span> <span class="o">+</span> <span class="s1">&#39;_history&#39;</span><span class="p">,</span>
                    <span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">p</span> <span class="o">+</span> <span class="s1">&#39;_history&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">:</span><span class="n">i</span> <span class="o">+</span> <span class="mi">1</span><span class="p">])</span></div>

<div class="viewcode-block" id="SingleStar.to_df"><a class="viewcode-back" href="../../../api/posydon.binary_evol.singlestar.html#posydon.binary_evol.singlestar.SingleStar.to_df">[docs]</a>    <span class="k">def</span> <span class="nf">to_df</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return history parameters from the star in a DataFrame.</span>
<span class="sd">        By default all parameters in STARPROPERTIES are included.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        extra_columns : list</span>
<span class="sd">            Extra star history parameters to return in DataFrame that are not</span>
<span class="sd">            included in STARPROPERTIES.</span>
<span class="sd">            Can be used in combination with `only_select_columns`.</span>
<span class="sd">            Assumes names have no suffix.</span>
<span class="sd">        ignore_columns : list</span>
<span class="sd">            Names of STARPROPERTIES parameters to ignore.</span>
<span class="sd">            Assumes names have `_history` suffix.</span>
<span class="sd">        only_select_columns : list</span>
<span class="sd">            Names of the only columns to include.</span>
<span class="sd">            Can be used in combination with `extra_columns`.</span>
<span class="sd">            Assumes names have `_history` suffix.</span>
<span class="sd">        null_value : float, optional</span>
<span class="sd">            Replace all None values with something else (for saving).</span>
<span class="sd">            Default is np.NAN.</span>
<span class="sd">        prefix : str, optional</span>
<span class="sd">            Prefix to all column names. (e.g. &#39;star_1&#39;, &#39;S1&#39;)</span>
<span class="sd">            Default has no prefix.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        pandas DataFrame</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">all_keys</span> <span class="o">=</span> <span class="p">[</span><span class="n">key</span><span class="o">+</span><span class="s1">&#39;_history&#39;</span> <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">STARPROPERTIES</span><span class="p">]</span> \
                   <span class="o">+</span> <span class="nb">list</span><span class="p">(</span><span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;extra_columns&#39;</span><span class="p">,</span> <span class="p">[]))</span>

        <span class="n">ignore_cols</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;ignore_columns&#39;</span><span class="p">,[]))</span>
        <span class="n">keys_to_save</span> <span class="o">=</span> <span class="p">[</span><span class="n">i</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">all_keys</span> \
                        <span class="k">if</span> <span class="ow">not</span> <span class="p">((</span><span class="n">i</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;_history&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span> <span class="ow">in</span> <span class="n">ignore_cols</span><span class="p">)</span> <span class="ow">or</span> <span class="p">(</span><span class="n">i</span> <span class="ow">in</span> <span class="n">ignore_cols</span><span class="p">))</span> <span class="p">]</span>

        <span class="k">if</span> <span class="nb">bool</span><span class="p">(</span><span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;only_select_columns&#39;</span><span class="p">)):</span>
            <span class="n">user_keys_to_save</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;only_select_columns&#39;</span><span class="p">))</span>
            <span class="n">keys_to_save</span> <span class="o">=</span> <span class="p">[</span><span class="n">key</span><span class="o">+</span><span class="s1">&#39;_history&#39;</span> <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">user_keys_to_save</span><span class="p">]</span> \
                            <span class="o">+</span> <span class="nb">list</span><span class="p">(</span><span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;extra_columns&#39;</span><span class="p">,</span> <span class="p">[]))</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="c1"># shape of data_to_save (history columns , time steps)</span>
            <span class="n">data_to_save</span> <span class="o">=</span> <span class="p">[</span><span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">key</span><span class="p">)</span> <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">keys_to_save</span><span class="p">]</span>
            <span class="n">where_none</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span> <span class="p">[</span><span class="kc">True</span> <span class="k">if</span> <span class="n">var</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="kc">False</span> <span class="k">for</span> <span class="n">var</span> <span class="ow">in</span> <span class="n">column</span><span class="p">]</span>
                                     <span class="k">for</span> <span class="n">column</span> <span class="ow">in</span> <span class="n">data_to_save</span><span class="p">],</span> <span class="n">dtype</span><span class="o">=</span><span class="nb">bool</span><span class="p">)</span>
        <span class="k">except</span> <span class="ne">AttributeError</span> <span class="k">as</span> <span class="n">err</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">AttributeError</span><span class="p">(</span> <span class="nb">str</span><span class="p">(</span><span class="n">err</span><span class="p">)</span> \
                    <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n\n</span><span class="s2">Available attributes in SingleStar: </span><span class="se">\n</span><span class="si">{}</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span> <span class="bp">self</span><span class="o">.</span><span class="vm">__dict__</span><span class="o">.</span><span class="n">keys</span><span class="p">())</span> <span class="p">)</span>

        <span class="c1"># casting into object array keeps things general</span>
        <span class="n">star_data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">data_to_save</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="nb">object</span><span class="p">)</span>
        <span class="c1"># Convert None to np.NAN by default</span>
        <span class="n">star_data</span><span class="p">[</span><span class="n">where_none</span><span class="p">]</span> <span class="o">=</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;null_value&#39;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">NAN</span><span class="p">)</span>
        <span class="c1"># sets rows as time steps, columns as history output</span>
        <span class="n">star_data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">transpose</span><span class="p">(</span><span class="n">star_data</span><span class="p">)</span>

        <span class="c1"># remove the _history at the end of all column names</span>
        <span class="n">prefix</span> <span class="o">=</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;prefix&#39;</span><span class="p">,</span> <span class="s2">&quot;&quot;</span><span class="p">)</span>
        <span class="n">column_names</span> <span class="o">=</span> <span class="p">[</span><span class="n">prefix</span> <span class="o">+</span> <span class="n">name</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;_history&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>
                        <span class="k">for</span> <span class="n">name</span> <span class="ow">in</span> <span class="n">keys_to_save</span> <span class="p">]</span>
        <span class="k">return</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">(</span><span class="n">star_data</span><span class="p">,</span> <span class="n">columns</span><span class="o">=</span><span class="n">column_names</span><span class="p">)</span></div>

    <span class="k">def</span> <span class="fm">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the object representation when print is called.&quot;&quot;&quot;</span>
        <span class="n">s</span> <span class="o">=</span> <span class="s1">&#39;&lt;</span><span class="si">{}</span><span class="s1">.</span><span class="si">{}</span><span class="s1"> at </span><span class="si">{}</span><span class="s1">&gt;</span><span class="se">\n</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="vm">__module__</span><span class="p">,</span>
                                     <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="vm">__name__</span><span class="p">,</span> <span class="nb">hex</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="bp">self</span><span class="p">)))</span>
        <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">STARPROPERTIES</span><span class="p">:</span>
            <span class="n">s</span> <span class="o">+=</span> <span class="s1">&#39;</span><span class="si">{}</span><span class="s1">: </span><span class="si">{}</span><span class="se">\n</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">p</span><span class="p">,</span> <span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">p</span><span class="p">))</span>

        <span class="k">return</span> <span class="n">s</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>

<div class="viewcode-block" id="SingleStar.from_run"><a class="viewcode-back" href="../../../api/posydon.binary_evol.singlestar.html#posydon.binary_evol.singlestar.SingleStar.from_run">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">from_run</span><span class="p">(</span><span class="n">run</span><span class="p">,</span> <span class="n">history</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">profile</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">which_star</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Create a SingleStar object from a single-star grid run.&quot;&quot;&quot;</span>
        <span class="n">star</span> <span class="o">=</span> <span class="n">SingleStar</span><span class="p">()</span>
        <span class="n">star_history</span> <span class="o">=</span> <span class="n">run</span><span class="o">.</span><span class="n">history1</span>
        <span class="n">prefix</span> <span class="o">=</span> <span class="s2">&quot;S1&quot;</span>
        <span class="k">if</span> <span class="n">star_history</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">star</span>

        <span class="n">n_steps</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">star_history</span><span class="p">[</span><span class="s2">&quot;star_age&quot;</span><span class="p">])</span> <span class="k">if</span> <span class="n">history</span> <span class="k">else</span> <span class="mi">1</span>
        <span class="n">h_colnames</span> <span class="o">=</span> <span class="n">star_history</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">names</span>

        <span class="k">for</span> <span class="n">attr</span> <span class="ow">in</span> <span class="n">STARPROPERTIES</span><span class="p">:</span>
            <span class="c1"># get the corresponding column name (default=same name)</span>
            <span class="n">colname</span> <span class="o">=</span> <span class="n">STAR_ATTRIBUTES_FROM_STAR_HISTORY_SINGLE</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">attr</span><span class="p">,</span> <span class="n">attr</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">colname</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">colname</span> <span class="ow">in</span> <span class="n">h_colnames</span><span class="p">:</span>
                <span class="n">final_value</span> <span class="o">=</span> <span class="n">run</span><span class="o">.</span><span class="n">final_values</span><span class="p">[</span><span class="n">prefix</span> <span class="o">+</span> <span class="s2">&quot;_&quot;</span> <span class="o">+</span> <span class="n">colname</span><span class="p">]</span>
                <span class="k">if</span> <span class="n">history</span><span class="p">:</span>
                    <span class="n">col_history</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">star_history</span><span class="p">[</span><span class="n">colname</span><span class="p">])</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">col_history</span> <span class="o">=</span> <span class="p">[</span><span class="n">final_value</span><span class="p">]</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">final_value</span> <span class="o">=</span> <span class="kc">None</span>
                <span class="n">col_history</span> <span class="o">=</span> <span class="p">[</span><span class="kc">None</span><span class="p">]</span> <span class="o">*</span> <span class="n">n_steps</span>
            <span class="k">assert</span> <span class="n">n_steps</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">col_history</span><span class="p">)</span>
            <span class="nb">setattr</span><span class="p">(</span><span class="n">star</span><span class="p">,</span> <span class="n">attr</span> <span class="o">+</span> <span class="s2">&quot;_history&quot;</span><span class="p">,</span> <span class="n">col_history</span><span class="p">)</span>
            <span class="nb">setattr</span><span class="p">(</span><span class="n">star</span><span class="p">,</span> <span class="n">attr</span><span class="p">,</span> <span class="n">final_value</span><span class="p">)</span>

        <span class="k">try</span><span class="p">:</span>
            <span class="n">star</span><span class="o">.</span><span class="n">metallicity</span> <span class="o">=</span> <span class="n">run</span><span class="o">.</span><span class="n">initial_values</span><span class="p">[</span><span class="s2">&quot;Z&quot;</span><span class="p">]</span>
        <span class="k">except</span> <span class="ne">AttributeError</span><span class="p">:</span>
            <span class="n">star</span><span class="o">.</span><span class="n">metallicity</span> <span class="o">=</span> <span class="kc">None</span>

        <span class="n">star</span><span class="o">.</span><span class="n">state_history</span> <span class="o">=</span> <span class="p">[</span><span class="n">check_state_of_star</span><span class="p">(</span><span class="n">star</span><span class="p">,</span> <span class="n">i</span><span class="o">=</span><span class="n">i</span><span class="p">,</span> <span class="n">star_CO</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
                              <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">n_steps</span><span class="p">)]</span>
        <span class="n">star</span><span class="o">.</span><span class="n">state</span> <span class="o">=</span> <span class="n">star</span><span class="o">.</span><span class="n">state_history</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>

        <span class="k">if</span> <span class="n">profile</span><span class="p">:</span>
            <span class="n">star</span><span class="o">.</span><span class="n">profile</span> <span class="o">=</span> <span class="n">run</span><span class="o">.</span><span class="n">final_profile1</span>

        <span class="k">return</span> <span class="n">star</span></div></div>
</pre></div>

           </div>
           
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2019, Tassos Fragkos.

    </p>
  </div>
    
    
    
    Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    
    provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>